<?php

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
include_once(realpath(dirname(__FILE__)) . "/Infosupclientdesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/Infosupclientcorresp.class.php");

class Infosupclient extends PluginsClassiques{

	var $id;
	var $intitule;
	var $nomvar;
	var $obligatoire;
	var $stocker;
	var $type;
	var $multiple;
	var $format;
	var $minimum;
	var $fonction;

	var $urlerrcreercompte="/?fond=formulerr&errform=1";
	var $urlerrmodifiercompte="/?fond=compte_modifiererr&errform=1";

	const TABLE = "infosupclient";
	var $table=self::TABLE;

	var $bddvars = array("id", "intitule", "nomvar", "obligatoire", "stocker", "type", "multiple", "format", "minimum", "fonction");

	function Infosupclient(){
		$this->PluginsClassiques();
	}

	function init(){
		$query_infosupclient = "CREATE TABLE IF NOT EXISTS `infosupclient` (
		  `id` int(11) NOT NULL auto_increment PRIMARY KEY,
		  `intitule` text collate latin1_german2_ci NOT NULL,
		  `nomvar` text collate latin1_german2_ci NOT NULL,
		  `obligatoire` int(11) NOT NULL,
		  `stocker` int(11) NOT NULL,
		  `type` int(11) NOT NULL,
		  `multiple` int(11) NOT NULL,
		  `format` text collate latin1_german2_ci NOT NULL,
		  `minimum` int(11) NOT NULL,
		  `fonction` text collate latin1_german2_ci NOT NULL
		);";
		$resul_infosupclient = $this->query($query_infosupclient);
		$query_infosupclientdesc = "CREATE TABLE IF NOT EXISTS `infosupclientdesc` (
		  `id` int(11) NOT NULL auto_increment PRIMARY KEY,
		  `infosupclient` int(11) NOT NULL,
		  `client` int(11) NOT NULL,
		  `valeur` text collate latin1_german2_ci NOT NULL
		);";
		$resul_infosupclientdesc = $this->query($query_infosupclientdesc);
		$query_infosupclientcorresp = "CREATE TABLE IF NOT EXISTS `infosupclientcorresp` (
		  `id` int(11) NOT NULL auto_increment PRIMARY KEY,
		  `infosupclient` int(11) NOT NULL,
		  `valeur` int(11) NOT NULL,
		  `intitule` text collate latin1_german2_ci NOT NULL
		);";
		$resul_infosupclientcorresp = $this->query($query_infosupclientcorresp);

		$this->query("ALTER TABLE `infosupclientdesc` ADD INDEX ( `infosupclient` , `client` )");
	}

	function charger($id){
		return $this->getVars("select * from $this->table where id=\"$id\"");
	}

	function creervar($intitule){
		$intitule = html_entity_decode($intitule, ENT_QUOTES);
		$intitule = strtolower($intitule);
		$intitule = preg_replace("/[^a-zA-Z0-9\-_]/", "", supprAccent($intitule));
		return $intitule;
	}

	function destroy(){
	}


	function avantclient(){
		global $action;
		if($action=="creercompte"){
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			$erreur=0;
			$tab=array();
			while($row = mysql_fetch_object($resul)){
				if(!$row->multiple){
					if($row->obligatoire && $_REQUEST[$row->nomvar]==""){
						$erreur=1;
					}else if($_REQUEST[$row->nomvar]!=""){
						if($row->minimum && strlen($_REQUEST[$row->nomvar])<$row->minimum){
							$erreur=1;
						}else if($row->format!="" && !preg_match($row->format,$_REQUEST[$row->nomvar])){
							$erreur=1;
						}else if($row->fonction!=""){
							preg_match("`function([\s]*)([^\(\s]*)`", $row->fonction, $cut);
							$func = "".$cut[2]."";
							if($func!=""){
								eval($row->fonction);
								if(!$func($_REQUEST[$row->nomvar])){
									$erreur=1;
								}
							}
						}
					}
					if($row->type==2 && $_REQUEST[$row->nomvar]==""){
						$_REQUEST[$row->nomvar]=0;
					}
				}else{
					if($row->obligatoire && count($_REQUEST[$row->nomvar])==0){
						$erreur=1;
					}else{
						foreach($_REQUEST[$row->nomvar] as $valeur){
							if($valeur!=""){
								if($row->minimum && strlen($valeur)<$row->minimum){
									$erreur=1;
								}else if($row->format!="" && !preg_match($row->format,$valeur)){
									$erreur=1;
								}else if($row->fonction!=""){
									preg_match("`function([\s]*)([^\(\s]*)`", $row->fonction, $cut);
									$func = "".$cut[2]."";
									if($func!=""){
										eval($row->fonction);
										if(!$func($valeur)){
											$erreur=1;
										}
									}
								}
							}
						}
					}
				}
				$tab[$row->nomvar]=$_REQUEST[$row->nomvar];
			}

			$_SESSION['navig']->formcli->forminfosup = $tab;
			if($erreur){
				if(isset($_REQUEST['urlerr']) && $_REQUEST['urlerr']!=""){
					redirige($_REQUEST['urlerr']);
				}else{
					$urlsite = new Variable("urlsite");
					redirige($urlsite->valeur . $this->urlerrcreercompte);
				}
			}
		}
	}

	function apresclient($client){
		global $action;
		if($action=="creercompte"){
			$tclient = new Client();
			$tclient->charger_mail($client->email);
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			$tab=array();
			while($row = mysql_fetch_object($resul)){
				if($row->stocker){
					if($row->type==2 && $_REQUEST[$row->nomvar]==""){
						$_REQUEST[$row->nomvar]=0;
					}
					if($row->multiple){
						foreach ($_REQUEST[$row->nomvar] as $valeur) {
							$infosupclientdesc = new Infosupclientdesc();
							$infosupclientdesc->infosupclient=$row->id;
							$infosupclientdesc->client=$tclient->id;
							$infosupclientdesc->valeur=$valeur;
							$infosupclientdesc->add();
						}
					}else{
						$infosupclientdesc = new Infosupclientdesc();
						$infosupclientdesc->infosupclient=$row->id;
						$infosupclientdesc->client=$tclient->id;
						$infosupclientdesc->valeur=$_REQUEST[$row->nomvar];
						$infosupclientdesc->add();
					}
				}
			}
		}
	}
	function avantmodifcompte(){
		global $action;
		if($action=="modifiercompte" || $action=="modifierinfosup"){
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			$erreur=0;
			$tab=array();
			while($row = mysql_fetch_object($resul)){
				if($row->stocker){
					if(!isset($_REQUEST[$row->nomvar])){
						continue;
					}
					if(!$row->multiple){
						if($row->obligatoire && $_REQUEST[$row->nomvar]==""){
							$erreur=1;
						}else if($_REQUEST[$row->nomvar]!=""){
							if($row->minimum && strlen($_REQUEST[$row->nomvar])<$row->minimum){
								$erreur=1;
							}else if($row->format!="" && !preg_match($row->format,$_REQUEST[$row->nomvar])){
								$erreur=1;
							}else if($row->fonction!=""){
								preg_match("`function([\s]*)([^\(\s]*)`", $row->fonction, $cut);
								$func = "".$cut[2]."";
								if($func!=""){
									eval($row->fonction);
									if(!$func($_REQUEST[$row->nomvar])){
										$erreur=1;
									}
								}
							}
						}
						if($row->type==2 && $_REQUEST[$row->nomvar]==""){
							$_REQUEST[$row->nomvar]=0;
						}
					}else{
						if($row->obligatoire && count($_REQUEST[$row->nomvar])==0){
							$erreur=1;
						}else{
							foreach($_REQUEST[$row->nomvar] as $valeur){
								if($valeur!=""){
									if($row->minimum && strlen($valeur)<$row->minimum){
										$erreur=1;
									}else if($row->format!="" && !preg_match($row->format,$valeur)){
										$erreur=1;
									}else if($row->fonction!=""){
										preg_match("`function([\s]*)([^\(\s]*)`", $row->fonction, $cut);
										$func = "".$cut[2]."";
										if($func!=""){
											eval($row->fonction);
											if(!$func($valeur)){
												$erreur=1;
											}
										}
									}
								}
							}
						}
					}
				}
				$tab[$row->nomvar]=$_REQUEST[$row->nomvar];
			}
			$_SESSION['navig']->formcli->forminfosup = $tab;
			if($erreur){
				if(isset($_REQUEST['urlerr']) && $_REQUEST['urlerr']!=""){
					redirige($_REQUEST['urlerr']);
				}else{
					$urlsite = new Variable("urlsite");
					redirige($urlsite->valeur . $this->urlerrmodifiercompte);
				}
			}
		}
	}
	function apresmodifcompte(){
		global $action;
		if($action=="modifiercompte" || $action=="modifierinfosup"){
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			while($row = mysql_fetch_object($resul)){
				if($row->stocker && isset($_REQUEST[$row->nomvar])){
					if($row->multiple){
						$infosupclientdesc = new Infosupclientdesc();
						$query = "delete from $infosupclientdesc->table where client='".$_SESSION['navig']->client->id."' and infosupclient='".$row->id."'";
						mysql_query($query, $infosupclientdesc->link);
						foreach ($_REQUEST[$row->nomvar] as $valeur) {
							$infosupclientdesc = new Infosupclientdesc();
							$infosupclientdesc->infosupclient=$row->id;
							$infosupclientdesc->client=$_SESSION['navig']->client->id;
							$infosupclientdesc->valeur=$valeur;
							$infosupclientdesc->add();
						}
					}else{
						$infosupclientdesc = new Infosupclientdesc();
						$infosupclientdesc->charger($row->id, $_SESSION['navig']->client->id);
						$infosupclientdesc->valeur=$_REQUEST[$row->nomvar];
						if($infosupclientdesc->id){
							$infosupclientdesc->maj();
						}else{
							$infosupclientdesc->infosupclient=$row->id;
							$infosupclientdesc->client=$_SESSION['navig']->client->id;
							$infosupclientdesc->add();
						}
					}
				}
			}
		}
	}
	function action(){
		global $res, $action;
		if($action=="modifierinfosup"){
			$this->avantmodifcompte();
			$this->apresmodifcompte();
		}
		if(isset($_GET['errform']) && $_GET['errform'] == "1"){
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			while($row = mysql_fetch_object($resul)){
				$erreur=0;
				if($row->obligatoire && $_SESSION['navig']->formcli->forminfosup[$row->nomvar]==""){
					$res = preg_replace("/\#".strtoupper($row->nomvar)."\[([^]]*)\]/", "\\1", $res);
				}else{
					$res = preg_replace("/\#".strtoupper($row->nomvar)."\[[^]]*\]/", "", $res);
				}
				if($_SESSION['navig']->formcli->forminfosup[$row->nomvar]!=""){
					if($row->minimum && strlen($_SESSION['navig']->formcli->forminfosup[$row->nomvar])<$row->minimum){
						$res = preg_replace("/\#ERR1_".strtoupper($row->nomvar)."\[([^]]*)\]/", "\\1", $res);
						$erreur=1;
					}else{
						$res = preg_replace("/\#ERR1_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					}
					if($row->format!="" && !preg_match($row->format,$_SESSION['navig']->formcli->forminfosup[$row->nomvar]) && !$erreur){
						$res = preg_replace("/\#ERR2_".strtoupper($row->nomvar)."\[([^]]*)\]/", "\\1", $res);
						$erreur=1;
					}else{
						$res = preg_replace("/\#ERR2_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					}
					if($row->fonction!="" && !$erreur){
						preg_match("`function([\s]*)([^\(\s]*)`", $row->fonction, $cut);
						$func = "".$cut[2]."";
						if($func!=""){
							eval($row->fonction);
							if(!$func($_SESSION['navig']->formcli->forminfosup[$row->nomvar])){
								$res = preg_replace("/\#ERR3_".strtoupper($row->nomvar)."\[([^]]*)\]/", "\\1", $res);
								$erreur=1;
							}else{
								$res = preg_replace("/\#ERR3_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
							}
						}
					}else{
						$res = preg_replace("/\#ERR3_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					}
					if($erreur){
						$res = preg_replace("/\#ERR_".strtoupper($row->nomvar)."\[([^]]*)\]/", "\\1", $res);
					}else{
						$res = preg_replace("/\#ERR_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					}
				}else{
					$res = preg_replace("/\#ERR1_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					$res = preg_replace("/\#ERR2_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					$res = preg_replace("/\#ERR3_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
					$res = preg_replace("/\#ERR_".strtoupper($row->nomvar)."\[([^]]*)\]/", "", $res);
				}
				$res = str_replace("#".strtoupper($row->nomvar), $_SESSION['navig']->formcli->forminfosup[$row->nomvar], $res);
				if(strstr($res, "#CHECK_".strtoupper($row->nomvar))){
					if($_SESSION['navig']->formcli->forminfosup[$row->nomvar]==1){
						$res = str_replace("#CHECK_".strtoupper($row->nomvar), "checked=\"checked\"", $res);
					}else{
						$res = str_replace("#CHECK_".strtoupper($row->nomvar), "", $res);
					}
				}else{
					preg_match_all("`\#CHECK([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
					$tab1 = "";
					$tab2 = "";
					for($i=0; $i<count($cut[1]); $i++){
						if(trim($cut[1][$i]) == $_SESSION['navig']->formcli->forminfosup[$row->nomvar]){
							$tab1[$i] = "#CHECK".$cut[1][$i]."_".strtoupper($row->nomvar);
							$tab2[$i] = "checked=\"checked\"";
						}
						else{
							$tab1[$i] = "#CHECK".$cut[1][$i]."_".strtoupper($row->nomvar);
							$tab2[$i] = "";
						}
					}
					$res = str_replace($tab1, $tab2, $res);
					preg_match_all("`\#SELECT([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
					$tab1 = "";
					$tab2 = "";
					for($i=0; $i<count($cut[1]); $i++){
						if(trim($cut[1][$i]) == $_SESSION['navig']->formcli->forminfosup[$row->nomvar]){
							$tab1[$i] = "#SELECT".$cut[1][$i]."_".strtoupper($row->nomvar);
							$tab2[$i] = "selected=\"selected\"";
						}
						else{
							$tab1[$i] = "#SELECT".$cut[1][$i]."_".strtoupper($row->nomvar);
							$tab2[$i] = "";
						}
					}
					$res = str_replace($tab1, $tab2, $res);
				}
			}
			$res = str_replace("#INFOSUPCLIENT_ERRFORM", "1", $res);
		}else{
			$res = str_replace("#INFOSUPCLIENT_ERRFORM", "", $res);
			$infosupclient = new Infosupclient();
			$query = "select * from $infosupclient->table";
			$resul = mysql_query($query, $infosupclient->link);
			while($row = mysql_fetch_object($resul)){
				if($_SESSION['navig']->client->id != ""){
					$infosupclientdesc = new Infosupclientdesc();
					$infosupclientdesc->charger($row->id, $_SESSION['navig']->client->id);
					$res = str_replace("#INFOSUPCLIENT_".strtoupper($row->nomvar), $infosupclientdesc->valeur, $res);
					if(strstr($res, "#CHECK_".strtoupper($row->nomvar))){
						if($infosupclientdesc->valeur==1){
							$res = str_replace("#CHECK_".strtoupper($row->nomvar), "checked=\"checked\"", $res);
						}else{
							$res = str_replace("#CHECK_".strtoupper($row->nomvar), "", $res);
						}
					}else{
						preg_match_all("`\#CHECK([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
						$tab1 = "";
						$tab2 = "";
						for($i=0; $i<count($cut[1]); $i++){
							if(trim($cut[1][$i]) == $infosupclientdesc->valeur){
								$tab1[$i] = "#CHECK".$cut[1][$i]."_".strtoupper($row->nomvar);
								$tab2[$i] = "checked=\"checked\"";
							}
							else{
								$tab1[$i] = "#CHECK".$cut[1][$i]."_".strtoupper($row->nomvar);
								$tab2[$i] = "";
							}
						}
						$res = str_replace($tab1, $tab2, $res);
						preg_match_all("`\#SELECT([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
						$tab1 = "";
						$tab2 = "";
						for($i=0; $i<count($cut[1]); $i++){
							if(trim($cut[1][$i]) == $infosupclientdesc->valeur){
								$tab1[$i] = "#SELECT".$cut[1][$i]."_".strtoupper($row->nomvar);
								$tab2[$i] = "selected=\"selected\"";
							}
							else{
								$tab1[$i] = "#SELECT".$cut[1][$i]."_".strtoupper($row->nomvar);
								$tab2[$i] = "";
							}
						}
						$res = str_replace($tab1, $tab2, $res);
					}
				}else{
					$res = str_replace("#INFOSUPCLIENT_".strtoupper($row->nomvar), "", $res);
					$res = str_replace("#CHECK_".strtoupper($row->nomvar), "", $res);
					preg_match_all("`\#CHECK([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
					$tab1 = "";
					$tab2 = "";
					for($i=0; $i<count($cut[1]); $i++){
						$tab1[$i] = "#CHECK".$cut[1][$i]."_".strtoupper($row->nomvar);
						$tab2[$i] = "";
					}
					$res = str_replace($tab1, $tab2, $res);
					preg_match_all("`\#SELECT([0-9]*)_".strtoupper($row->nomvar)."`", $res, $cut);
					$tab1 = "";
					$tab2 = "";
					for($i=0; $i<count($cut[1]); $i++){
						$tab1[$i] = "#SELECT".$cut[1][$i]."_".strtoupper($row->nomvar);
						$tab2[$i] = "";
					}
					$res = str_replace($tab1, $tab2, $res);
				}
			}
		}
	}

	function modcli($cli){
		$client = new Client();
		$client->charger_ref($cli->ref);

		$infosupclient = new Infosupclient();
		$query = "select * from $infosupclient->table";
		$resul = mysql_query($query, $infosupclient->link);
		while($row = mysql_fetch_object($resul)){
			if($row->stocker && isset($_REQUEST[$row->nomvar])){
				if($row->multiple){
					$infosupclientdesc = new Infosupclientdesc();
					$query = "delete from $infosupclientdesc->table where client='".$client->id."' and infosupclient='".$row->id."'";
					mysql_query($query, $infosupclientdesc->link);
					foreach ($_REQUEST[$row->nomvar] as $valeur) {
						$infosupclientdesc = new Infosupclientdesc();
						$infosupclientdesc->infosupclient=$row->id;
						$infosupclientdesc->client=$client->id;
						$infosupclientdesc->valeur=$valeur;
						$infosupclientdesc->add();
					}
				}else{
					$infosupclientdesc = new Infosupclientdesc();
					if ($infosupclientdesc->charger($row->id, $client->id)) {
						$infosupclientdesc->valeur=$_REQUEST[$row->nomvar];
						$infosupclientdesc->maj();
					}else{
						$infosupclientdesc->infosupclient=$row->id;
						$infosupclientdesc->client=$client->id;
						$infosupclientdesc->valeur=$_REQUEST[$row->nomvar];
						$infosupclientdesc->add();
					}
				}
			}
		}
	}

	public static function set($idclient, $nomvariable, $valeur) {


		$result = mysql_query("select id from ".self::TABLE." where nomvar='$nomvariable'");

		if ($result) {
			$id = mysql_result($result, 0);

			if ($id) {
				$infosupclientdesc = new Infosupclientdesc();

				if ($infosupclientdesc->charger($id, $idclient)) {
					$infosupclientdesc->valeur = $valeur;
					$infosupclientdesc->maj();
				} else {
					$infosupclientdesc->infosupclient = $id;
					$infosupclientdesc->client = $idclient;
					$infosupclientdesc->valeur = $valeur;
					$infosupclientdesc->add();
				}
			}
		}
	}

	public static function get($idclient, $nomvariable) {

		$result = mysql_query("select id from ".self::TABLE." where nomvar='$nomvariable'");

		if ($result) {
			$id = mysql_result($result, 0);

			if ($id) {
				$infosupclientdesc = new Infosupclientdesc();

				if ($infosupclientdesc->charger($id, $idclient))
					return $infosupclientdesc->valeur;
			}
		}

		return false;
	}

	function boucle($texte, $arg){
		$id = lireTag($arg, "id");
		$nomvar = lireTag($arg, "nomvar");
		$err = lireTag($arg, "erreur");

		$infosupclientcorresp = new infosupclientcorresp();
		if($id!="" && $nomvar!="") $nomvar="";

		if($id!="") $query = "select * from infosupclientcorresp where infosupclient=\"$id\" ";
		if($nomvar!="") $query = "select infosupclientcorresp.* from infosupclient left join infosupclientcorresp on (infosupclient.id=infosupclientcorresp.infosupclient) where infosupclient.nomvar=\"$nomvar\" ";
		$resul = mysql_query($query, $infosupclientcorresp->link);
		$nbres = mysql_num_rows($resul);
		if(!$nbres) return "";

		while( $row = mysql_fetch_object($resul)){

			$temp = str_replace("#VALEUR", "$row->valeur", $texte);
			$temp = str_replace("#INTITULE", "$row->intitule", $temp);
			$temp = str_replace("#ID", "$row->id", $temp);

			$checked=$selected="";
			$infosupclient = new infosupclient();
			$infosupclient->charger($row->infosupclient);
			if($infosupclient->id){
				if($infosupclient->multiple){
					$valeurs=array();
					if($err){
						if($_SESSION['navig']->formcli->forminfosup[$infosupclient->nomvar]){
							$valeurs=$_SESSION['navig']->formcli->forminfosup[$infosupclient->nomvar];
						}
					}else if($_SESSION['navig']->client->id){
						$infosupclientdesc = new Infosupclientdesc();
						$query = "select * from $infosupclientdesc->table where client='".$_SESSION['navig']->client->id."' and infosupclient='".$infosupclient->id."'";
						$result = mysql_query($query, $infosupclientdesc->link);
						while($row2 = mysql_fetch_object($result)){
							$valeurs[]=$row2->valeur;
						}
					}
					if (is_array($valeurs)) {
						if(in_array($row->valeur, $valeurs)) {
							$checked="checked=\"checked\"";
							$selected="selected=\"selected\"";
						}
					}
				}else{
					$valeur="";
					if($err){
						if($_SESSION['navig']->formcli->forminfosup[$infosupclient->nomvar]){
							$valeur=$_SESSION['navig']->formcli->forminfosup[$infosupclient->nomvar];
						}
					}else if($_SESSION['navig']->client->id){
						$infosupclientdesc = new Infosupclientdesc();
						$infosupclientdesc->charger($infosupclient->id, $_SESSION['navig']->client->id);
						$valeur=$infosupclientdesc->valeur;
					}
					if($valeur==$row->valeur){
						$checked="checked=\"checked\"";
						$selected="selected=\"selected\"";
					}
				}
			}
			$temp = str_replace("#CHECKED", $checked, $temp);
			$temp = str_replace("#SELECTED", $selected, $temp);

			$res .= $temp;
		}

		return $res;
	}


}
?>